
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 * $Id: bag.h,v 1.4 1998/04/29 21:44:46 stes Exp $
 */

#ifndef __OBJBAG_H__
#define __OBJBAG_H__

#include "cltn.h"

typedef struct objbag {
  int count;			/* != size */
  int capacity;
  id *ptr;
  int *cnts;
} *objbag_t;

@interface Bag : Cltn
{
  struct objbag value;
}

+ new;
+ new:(unsigned)n;
+ with:(int)nArgs,...;
+ with:firstObject with:nextObject;
+ add:firstObject;
- copy;
- deepCopy;
- emptyYourself;
- freeContents;
- free;

- (unsigned) size;
- (BOOL) isEmpty;
- eachElement;

- (BOOL) isEqual:aSet;

- add:anObject;
- addNTest:anObject;
- filter:anObject;
- add:anObject ifDuplicate:aBlock;
- replace:anObject;

- remove:oldObject;
- remove:oldObject ifAbsent:exceptionBlock;

- (BOOL) includesAllOf:aCltn;
- (BOOL) includesAnyOf:aCltn;

- addAll:aCltn;
- addContentsOf:aCltn;
- addContentsTo:aCltn;
- removeAll:aCltn;
- removeContentsFrom:aCltn;
- removeContentsOf:aCltn;

- asSet;
- asOrdCltn;

#ifdef __PORTABLE_OBJC__

- detect:aBlock;
- detect:aBlock ifNone:noneBlock;
- select:testBlock;
- reject:testBlock;
- collect:transformBlock;
- (unsigned) count:aBlock;
#endif				/* __PORTABLE_OBJC__ */


- elementsPerform:(SEL)aSelector;
- elementsPerform:(SEL)aSelector with:anObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject with:thirdObj;

#ifdef __PORTABLE_OBJC__

- do:aBlock;
- do:aBlock until:(BOOL*)flag;
#endif				/* __PORTABLE_OBJC__ */


- find:anObject;
- (BOOL) contains:anObject;
- (BOOL) includes:anObject;
- (unsigned) occurrencesOf:anObject;

- intersection:aSet;
- union:aSet;
- difference:aSet;

- printOn:(IOD)aFile;

#ifdef __PORTABLE_OBJC__
- fileOutOn:aFiler;
- fileInFrom:aFiler;
- awakeFrom:aFiler;
#endif				/* __PORTABLE_OBJC__ */

@end

#endif				/* __OBJBAG_H__ */
