
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 * $Id: ocstring.h,v 1.10 1998/04/29 21:55:00 stes Exp $
 */

#ifndef __OBJSTR_H__
#define __OBJSTR_H__

#include "array.h"

typedef struct objstr {
  int count;
  int capacity;
  char *ptr;
} *objstr_t;

@interface String : Array
{
  struct objstr value;
}

+ new;
+ new:(unsigned)nChars;
+ str:(STR)strValue;
+ chars:(STR)strValue count:(int)n;
+ sprintf:(STR)format,...;
- copy;
- deepCopy;
- free;

- (int) compare:aStr;
- (int) compareSTR:(STR)strValue;
- (unsigned) hash;
- (int) dictCompare:aStr;
- (BOOL) isEqual:aStr;
- (BOOL) isEqualSTR:(STR)strValue;

- (unsigned) size;
- (char) charAt:(unsigned)anOffset;
- (char) charAt:(unsigned)anOffset put:(char)aChar;

- (STR) strcat:(STR)aBuffer;
- concatSTR:(STR)strValue;
- concatenateSTR:(STR)aString;
- assignSTR:(STR)strValue;
- assignSTR:(STR)strValue length:(unsigned)nChars;

- (double) asDouble;
- (int) asInt;
- (long) asLong;
- asSTR:(STR)aBuffer maxSize:(int)aSize;
- (STR) str;
- (STR) strCopy;

- toLower;
- toUpper;

- printOn:(IOD)aFile;

#ifdef __PORTABLE_OBJC__
- fileOutOn:aFiler;
- fileInFrom:aFiler;
#endif				/* __PORTABLE_OBJC__ */

@end

/* some defs needed when cross-compiling with a DIFFERENT compiler */
/* placed this here 'cause we will have a different objcrt.h and Object.h */

#if !defined(__PORTABLE_OBJC__) && !defined(OCLONGLONG)

void *OC_Malloc(size_t);	/* allocate memory from the system */
void *OC_MallocAtomic(size_t);	/* allocate memory from the system */
void *OC_Realloc(void *, size_t);	/* reallocate memory from the system */
void *OC_Free(void *data);	/* deallocate OC_Malloc'ed memory and return NULL */

#endif				/* __PORTABLE_OBJC__ */

#endif				/* __OBJSTR_H__ */
