
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 * $Id: ordcltn.h,v 1.10 1998/04/29 21:44:47 stes Exp $
 */

#ifndef __OBJCLTN_H__
#define __OBJCLTN_H__

#include "cltn.h"

/* the name of this class in older versions of objpak */
#define Collection OrdCltn
/* full name */
#define OrderedCollection OrdCltn

typedef struct objcol {
  int count;
  int capacity;
  id *ptr;
} *objcol_t;

@interface OrdCltn : Cltn
{
  struct objcol value;
}

+ new;
+ new:(unsigned)n;
+ with:(int)nArgs,...;
+ with:firstObject with:nextObject;
+ add:firstObject;
- copy;
- deepCopy;
- emptyYourself;
- freeContents;
- free;

- (unsigned) size;
- (BOOL) isEmpty;
- (unsigned) lastOffset;
- eachElement;
- firstElement;
- lastElement;

- (BOOL) isEqual:aCltn;

- add:anObject;
- addFirst:newObject;
- addLast:newObject;
- addIfAbsent:anObject;
- addIfAbsentMatching:anObject;

- at:(unsigned )anOffset insert:anObject;
- insert:newObject after:oldObject;
- insert:newObject before:oldObject;

- after:anObject;
- before:anObject;
- at:(unsigned )anOffset;
- at:(unsigned )anOffset put:anObject;

- removeFirst;
- removeLast;
- removeAt:(unsigned )anOffset;
- removeAtIndex:(unsigned )anOffset;
- remove:oldObject;
- remove:oldObject ifAbsent:exceptionBlock;

- (BOOL) includesAllOf:aCltn;
- (BOOL) includesAnyOf:aCltn;

- addAll:aCltn;
- addContentsOf:aCltn;
- addContentsTo:aCltn;
- removeAll:aCltn;
- removeContentsFrom:aCltn;
- removeContentsOf:aCltn;

- asSet;
- asOrdCltn;

#ifdef __PORTABLE_OBJC__

- detect:aBlock;
- detect:aBlock ifNone:noneBlock;
- select:testBlock;
- reject:testBlock;
- collect:transformBlock;
- (unsigned) count:aBlock;
#endif				/* __PORTABLE_OBJC__ */


- elementsPerform:(SEL)aSelector;
- elementsPerform:(SEL)aSelector with:anObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject with:thirdObj;

#ifdef __PORTABLE_OBJC__

- do:aBlock;
- do:aBlock until:(BOOL*)flag;
- reverseDo:aBlock;
#endif				/* __PORTABLE_OBJC__ */


- find:anObject;
- findMatching:anObject;
- (BOOL) includes:anObject;
- findSTR:(STR )strValue;
- (BOOL) contains:anObject;
- (unsigned) offsetOf:anObject;

- printOn:(IOD)aFile;

#ifdef __PORTABLE_OBJC__
- fileOutOn:aFiler;
- fileInFrom:aFiler;
#endif				/* __PORTABLE_OBJC__ */

@end

#endif				/* __OBJCLTN_H__ */
