
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 * $Id: octext.h,v 1.2 1998/10/25 21:32:39 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __OBJTXT_H__
#define __OBJTXT_H__

#include <Object.h>
#include <stdio.h>

@interface Text : Object
{
  id string;
  id runs;
}

- check;
+ new;
+ new:(unsigned)nChars;
+ vsprintf:(STR)format:(OC_VA_LIST*)ap;
+ str:(STR)aString;
+ sprintf:(STR)format,...;
+ fromString:aString;
+ string:aString attribute:attrib;
- string:aString runs:anArray;
- copy;
- free;

- (unsigned) hash;
- (BOOL) isEqual:aStr;

- string;
- runs;
- (STR) str;
- (unsigned) size;
- (char) charAt:(unsigned)anOffset;
- (char) charAt:(unsigned)anOffset put:(char)aChar;

- allBold;
- makeBoldFrom:(unsigned)p to:(unsigned)q;
- addAttribute:attribute;
- addAttribute:attribute from:(unsigned)p to:(unsigned)q;
- attributesAt:(unsigned)i;
- (unsigned) runLengthFor:(unsigned)i;
- (unsigned) fontNumberAt:(unsigned)i;
- fontAt:(unsigned)i withStyle:textStyle;

- asString;
- asText;
- asParagraph;

- printOn:(IOD)aFile;
@end

#endif				/* __OBJTXT_H__ */

