
/*
 * Portable Object Compiler (c) 1998.  All Rights Reserved.
 * $Id: assign.m,v 1.10 1998/10/06 15:23:42 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include "assign.h"
#include "ordcltn.h"
#include "output.h"
#include "methimpl.h"
#include "classdef.h"
#include "options.h"
#include <assert.h>

@implementation Assignment
- genOn:stream
{
  id lhs, rhs, aClass = [ClassDefinition current];

  assert([subnodes size] == 3);
  lhs = [subnodes at:0];
  rhs = [subnodes at:2];

  if ((lhs != nil) && [lhs isEqualSTR:"self"] &&
      (currimpl != nil)) {

    if ([options selfAssign] == NO) {
      fatalError("assignment not allowed with -noSelfAssign");
    }
    /* deliberately do NOT emit the lhs Identifier "self"
     * which would be translated to (id)self.  it's not ANSI C
     * to have something like (id) self = ..., and some compilers
     * (icc or wcc, for instance) complain or warn about this lhs cast
     */

    if (![options otb]) {
      [stream echo:"self = (struct %s *)", [aClass privname]];
    } else {
      [stream echo:"self = (struct %s *)", [aClass otbname]];
    }

    [rhs genOn:stream];
  } else {
    [lhs genOn:stream];
    [stream echo:" = "];
    [rhs genOn:stream];
  }

  return self;
}

@end

