
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 * $Id: blockxpr.h,v 1.14 1998/10/06 15:23:43 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __BLOCKEXPRESSION_H__
#define __BLOCKEXPRESSION_H__

#include "xprnode.h"

extern id currentBlock;

@interface BlockExpression : ExpressionNode
{
  int count;
  id arguments;
  id argumentNames;
  id argumentTypes;
  id compstmt;
  id scope;			/* collection of enclosing compounds referenced */
}

- block;
+ new;
- free;
- blkfuncname;
- blkdataname;
- blktypename;
- scope;
- setArguments:aNode;
- setDecls:dNode body:bNode;
- setStatements:aNode;
- setExpression:aNode;
- (int) nArgs;
- grepTmpvars:aStmt;
- grepBlocks:aStmt;
- grepTopblks:aStmt;
- grepCaches:aStmt;
- addScope:aScope;
- blkdatatypOn:stream;
- packblockOn:stream;
- unpackblockOn:stream;
- processBlocks;
- pushScope;
- popScope;
- addArgs:compound;
- genblockdefsOn:stream;
- genOn:stream;
@end

#endif				/* __BLOCKEXPRESSION_H__ */

