
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: classdef.h,v 1.19 1998/10/06 15:23:43 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __CLASSDEFINITION_H__
#define __CLASSDEFINITION_H__

#include "node.h"

@interface ClassDefinition : Node
{
  BOOL prologueEmitted;
  BOOL isImplementation;
  BOOL interfaceEmitted;
  BOOL isCategory;
  id name;			/* for category Object (MyObject), this is MyObject */
  id superName;			/* for category , this is Object */
  id allIvars;
  id allCvars;
  id allItypes;
  id allCtypes;
  id setOfFMethods;
  id setOfIMethods;
  id ivarNodes;
  id totalIvars;
  id allIdivars;
  id cvarNodes;
  id totalCvars;
  id setOfIdCVars;
  id interface;
  id clsdisptbl;
  id nstDispatchTable;
}

- free;

+ findInterface:aName;
- addInterface;

- idName;
- (BOOL) isimpltoken;
- (BOOL) isintftoken;
- processName:myName superName:hisName;
- superName;
- (BOOL) isCategory;
- isCategory:(BOOL)flag;
+ declareIvar:aNode Itype:bNode;
- totalIvars;
- totalCvars;
+ (BOOL) inmethimpl;
+ (BOOL) iscurivar:anIdentifier;
+ (BOOL) iscurcvar:anIdentifier;
- processVars;
- superInterface;
- rootInterface;
- rootName;
+ grepIvarnodes:aNode;
+ grepCvarnodes:aNode;
- makeCurrent;
- allIvars;
- allCvars;
- allIdivars;
- ivarNodes;
- cvarNodes;
- clearCurrent;
- ivarscommentOn:stream;

- ivarnodesOn:stream;
- cvarnodesOn:stream;
- (STR) globalfun;
- (STR) structfun;
- (STR) superfun;
- (STR) metastructfun;
- (STR) metasuperfun;
- externclassOn:stream;
- interfaceOn:stream;

- isImplementation:(BOOL)flag;
+ checkpending;
+ new;
+ end;
+ currentName;
+ current;

- addClsdisp:aMethod;
- addNstdisp:aMethod;
- moddefs;

- (STR) privname;
- (STR) otbname;
- privOn:stream;
- (STR) sharedname;
- shartypeOn:stream;
- (STR) _clsdisptblname;
- (STR) _nstDispatchTblName;
- clsdisptblsOn:stream;
- nstdisptblsOn:stream;
- disptablesOn:stream;
- sharOn:stream;
- metasharOn:stream;
- globfuncallOn:stream;
- prologueOn:stream;
- superOn:stream;
- metasuperOn:stream;
- superfileOutmsg;
- superfileInmsg;
- fileOutmsg:ivar;
- fileInmsg:ivar;
- genfileOutcode:stream;
- genfileIncode:stream;
- filercodeOn:stream;
- globalOn:stream;
- epilogueOn:stream;
- makecurivars;
- clearcurivars;
- startimpl:stream;
- genOn:stream;
@end

#endif				/* __CLASSDEFINITION_H__ */

