
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: compstat.h,v 1.15 1998/10/06 15:23:43 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __COMPSTMT_H__
#define __COMPSTMT_H__

#include "node.h"

@interface CompoundStatement : Node
{
  int count;			/* unique number */
  id lBrace;
  id decls;			/* can be nil */
  id body;			/* can be nil */
  id rBrace;
  id tmpVars;
  id inlineCaches;
  id myBlocks;			/* not including those of subCompounds */
  id blocks;			/* including those of subCompounds,

				 * but not including any subBlocks of a Block 
				 * (see -grepBlocks:)
				 */
  BOOL ismain;
  id outertag;			/* linetag of main() */
  id localTypes;
  id localVariables;
  id blockTypes;
  id blockVariables;		/* those locals that are referenced from a Block */
  id initvars;			/* variables that have an initializer */
}

- grepTopblks:compound;
- lbrace:lToken decls:aDecls body:aBody rbrace:rToken;
+ lbrace:lToken body:aBody rbrace:rToken;
+ lbrace:lToken decls:aDecls body:aBody rbrace:rToken;

- setDeclarators:declarators;
- blockVariables;
- addInitvars:vars;
- addLocals:vars types:types;
- pushLocals;
- popLocals;
- refblockvar:anIdentifier;

- addTmpvar:aString;
- addBlock:aBlock;
- addTopblk:aBlock;
- addCache:aString;
- grepTmpvars:aStmt;
- grepCaches:aStmt;
- printtmpvars:stream from:(int)i to:(int)j;
- printtmpvars:stream;
- printcaches:stream from:(int)i to:(int)j;
- printcaches:stream;
- printblkdata:stream;

- scopetypename;
- scopeconsname;
- scopedataname;
- scopedatatypeOn:stream;
- genscopeOn:stream;
- copyscopeOn:stream;

- processBlocks;
- scopeconsOn:stream;
- genblockdefsOn:stream;
- genOn:stream;
- genmainOn:stream linetag:aTag;
@end

#endif				/* __COMPSTMT_H__ */

