
/*
 * Portable Object Compiler (c) 1998.  All Rights Reserved.
 * $Id: decls.m,v 1.15 1998/10/25 21:33:21 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include "decls.h"
#include "set.h"
#include "ordcltn.h"
#include "options.h"
#include "output.h"
#include "compstat.h"
#include <assert.h>

@implementation Declarators
static id collectTypes, collectVariables, collectInitvars;

+ declareLocals:aNode type:typeNode
{
  if (aNode) {

    if (!collectTypes)
      collectTypes = [OrdCltn new];
    if (!collectVariables)
      collectVariables = [OrdCltn new];
    if (!collectInitvars)
      collectInitvars = [Set new];	/* -contains: */

    /* collect locals while parsing - when the compound is created
     * these collections will be the localVariables and localTypes
     */

    [aNode grepIvars:collectVariables initvars:collectInitvars
     addItype:typeNode to:collectTypes];
  }
  return self;
}


#ifndef __PORTABLE_OBJC__
- show  {
  return self;
}				/* gnu */
#endif

- decls
{

  if (collectTypes) {
    types = collectTypes;
    variables = collectVariables;
    initvars = collectInitvars;

    collectTypes = nil;
    collectVariables = nil;
    collectInitvars = nil;

    if ([options debugInfo]) {
      fprintf(stderr, "----declarators-----\n");
      [types show];
      [variables show];
      fprintf(stderr, "--------------------\n");
    }
  }
  return self;
}

+ new
{
  return [[super new] decls];
}

- types
{
  return types;
}

- variables
{
  return variables;
}

- initvars
{
  return initvars;
}

- argsstmt:statements
{
  /* used by FunctionDefinition to add ANSI C style  
   * or K&R style function arguments, to the statements as (Initialized) Locals
   * (so that they may be used from within a Block)
   */

  [statements addLocals:variables types:types];
  [statements addInitvars:variables];
  return self;
}

@end

