
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: funccall.m,v 1.11 1998/10/06 15:23:44 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include "funccall.h"
#include "options.h"
#include "output.h"
#include "linetag.h"
#include "identif.h"
#include "ocstring.h"
#include "ordcltn.h"
#include "module.h"
#include <assert.h>

@implementation FunctionCall
- genOn:stream
{
  id name;
  int i, n;
  id primary = [subnodes at:0];

  /* mmh... what happens if we have a nontrivial expression 
   * as function name ?
   *
   * this is wrong (sort-o works since it doesn't harm to 
   * "use" more entries than we actually need 
   *
   * stes 9/97 : it's incorrect to do the usesEntry: only in
   * the case of an identifier, since then stuff like (*G)(x)
   * might not emit an OCU for a global G.
   *
   */

  name = [[primary findIdentifier] string];
  if (name)
    [Module usesEntry:name];

  /* following is a trick to prevent foo(x) to translate
   * to something like self->foo(x) (if foo is name of ivar)
   */

  n = [subnodes size];
  [primary funheadOn:stream];
  for (i = 1; i < n; i++)
    [[subnodes at:i] genOn:stream];
  return self;
}

@end

