
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: identif.h,v 1.21 1998/10/06 15:23:44 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __IDENTIFIER_H__
#define __IDENTIFIER_H__

#include "xprnode.h"

@interface Identifier : ExpressionNode
{
  id lineTag;
  id string;
  BOOL noMark;
}

- string:aString;
- lineTag;
+ str:(STR)s;
+ string:aString;
- copy;
- dontFree;
- free;

- (int) asInt;
- string;
- (BOOL) isEqual:anIdentifier;
- (unsigned) hash;
- (BOOL) isEqualSTR:(STR)s;
- (BOOL) isVoid;
- (BOOL) isPtr;
- (STR) str;

- warnlocalivar;
+ pushScope:aScope;
+ popScope;
+ pushvars:localVariables types:localTypes;
+ popLocals:localVariables;

- outputOn:stream;
- (BOOL) isSelf;
- (BOOL) isLocal;
- findblockvar;
- (BOOL) isIvar;
- (BOOL) isCvar;
+ selfOn:stream;
+ selfidOn:stream;
- genblockvarOn:aScope on:stream;
- genOn:stream ivarOf:aClassname;
- genOn:stream cvarOf:aClass;
- funheadOn:stream;
- genfieldOn:stream;
- genOn:stream;
- taglessOn:stream;
- print;

- markdecl:(BOOL)flag;
- defbuiltinfun;
- deftypename;
- deftemplate;
+ (BOOL) inTemplate;
+ endTemplate;
- defclassname;
- (BOOL) isbuiltinfun;
- (BOOL) istypename;
- (BOOL) isClassname;
- (STR) globalfun;
- (STR) structfun;
- (STR) superfun;
- (STR) metastructfun;
- (STR) metasuperfun;
- findIdentifier;

- grepIvars:aSet addItype:bNode to:bSet;
- grepIvars:aSet initvars:iv addItype:bNode to:bSet;
- grepScope:aBlock;
- (BOOL) containsStatic;
- forMethod:aMethod;
@end

#endif				/* __IDENTIFIER_H__ */

