
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: keywdecl.m,v 1.11 1998/10/06 15:23:44 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include "keywdecl.h"
#include "output.h"
#include "options.h"
#include "linetag.h"
#include "ordcltn.h"
#include "ocstring.h"
#include "methinfo.h"
#include "identif.h"
#include <assert.h>

@implementation KeyWordDeclarator
- free
{
  return nil;
}

- setName:aName
{
  name = aName;
  return self;
}

- idName
{
  return name;
}

- setArgument:aName
{
  argument = aName;
  return self;
}

- argument
{
  return argument;
}

- argumentType:aName
{
  argumentType = aName;
  return self;
}

- argumentType
{
  return argumentType;
}

- forMethod:aMethod
{
  if (name)
    [aMethod addComponent:[name string]];

  [aMethod addColon];

  if (argumentType) {
    [aMethod addArgtype:argumentType];
  } else {
    [aMethod addId];
  }

  if (argument)
    [aMethod addArgument:argument];

  return self;
}

@end

