
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: methinfo.h,v 1.23 1998/10/06 15:23:45 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __METHODINFO_H__
#define __METHODINFO_H__

#ifndef __OBJECT_INCLUDED__
#define __OBJECT_INCLUDED__
#include "Object.h"
#include <stdio.h>
#endif

@interface MethodInfo : Object
{
  BOOL isFactory;		/* for prototype only  */
  BOOL preventfwd;
  BOOL isselptr;
  BOOL didselptr;
  id name;
  id uscorename;
  id fwdname;
  id dispname;
  id argstructname;
  id resultType;		/* for prototype only  */
  id argumentTypes;		/* for prototype only  */
  id arguments;			/* in messageArguments */
  id ellipsis;			/* optional ... */
}


- free;
- prototype;
- implement;
+ findprotofor:aName;
- defaultargs;
+ findproto:aMethod;

- (BOOL) isEqual:aMethod;
- (BOOL) typeconflicts:b;
- (BOOL) istypeEqual:b;
- (unsigned) typehash;

- fullname;
- (STR) uscorename;
- preventfwd:(BOOL)flag;
- (BOOL) canforward;
- (BOOL) calcselptr;
- (BOOL) isselptr;
- (STR) fwdname;
- (STR) dispname;
- (STR) argstructname;
- funnameforclass:aClassName;
- isFactory:(BOOL)flag;
- (BOOL) isFactory;
- resType;
- (BOOL) isresultvoid;
- resType:aNode;
- addComponent:aString;
- addColon;
- addEllipsis:aToken;
- addArgtype:aNode;
- argumentTypes;
- addId;
- addArgument:aNode;
- checkwith;

- stdmsgargs;
- stdmsgtypes;
- grepLocals:aCompound;

- resulttypeOn:stream;
- castOn:stream;
- typesOn:stream;
- idselfcmdOn:stream;
- selfcmdOn:stream;
- protosOn:stream;
- genargsOn:stream;
- arguments:a;
- dispatchCopy;
- genargsintostructOn:stream;
- funprotoOn:stream;
- fwdstubOn:stream;
- argstructOn:stream;
- dispfunOn:stream;
- grepScope:aMethod;
@end

#endif				/* __METHODINFO_H__ */

