
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 * $Id: msgxpr.h,v 1.20 1998/10/06 15:23:45 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __MESSAGEEXPRESSION_H__
#define __MESSAGEEXPRESSION_H__

#include "xprnode.h"

@interface MessageExpression : ExpressionNode
{
  id receiver;
  id linetag;			/* emitted before (objcTx = ...) assignment */
  id methodMsg;
  id methodProto;
  id methodName;
  id tmpVar;
  id inlineCache;
  BOOL rcvrSuper;
  BOOL dispatch;
}


- processReceiver:aReceiver;
- msgargs:methdecl;
- dispatch:rcvr method:minfo;
- preventfwd:(BOOL)flag;
- (BOOL) canforward;
- (BOOL) isselptr;
- methodProto;
- (unsigned) hash;
- (BOOL) isEqual:msgxpr;
- grepTmpvars:aStmt;
- grepCaches:aStmt;

- receiver:rcvr keyw:kw;
+ receiver:rcvr keyw:kw;
- receiver:rcvr keyw:kw1 arg:a1;
+ receiver:rcvr keyw:kw1 arg:a1;
- receiver:rcvr keyw:kw1 arg:a1 keyw:kw2 arg:a2;
+ receiver:rcvr keyw:kw1 arg:a1 keyw:kw2 arg:a2;

- genOn:stream;
- assignrcvrOn:stream;
- assignsuperOn:stream;
- genimpOn:stream inSuper:(BOOL)inSuper;
- gencacheOn:stream inSuper:(BOOL)inSuper;
- gencallOn:stream inSuper:(BOOL)inSuper;
- msgargsOn:stream inSuper:(BOOL)inSuper;
- genmsgOn:stream inSuper:(BOOL)inSuper;
- msgOn:stream;
- supermsgOn:stream;
@end

#endif				/* __MESSAGEEXPRESSION_H__ */

