
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: node.h,v 1.22 1998/10/06 15:23:45 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __NODE_H__
#define __NODE_H__

#ifndef __OBJECT_INCLUDED__
#define __OBJECT_INCLUDED__
#include "Object.h"
#include <stdio.h>
#endif

extern id allTypenames;
extern id allClassnames;
extern int exitStatus;
char *tokenName(int token);
void fatalError(STR msg);
void warnError(STR msg);

@interface Node : Object
{
  id subnodes;
}

- node;
+ new;
- dodeepCopy;
- deepCopy;
- free;

- subnodes;
- (BOOL) isEqual:aNode;
- (BOOL) isEqualSTR:(STR)s;
- (int) asInt;
- process;

- (STR) str;
- (BOOL) isPtr;
- (BOOL) isId;
- (BOOL) isVoid;
- (BOOL) containsTypedef;
- deftypename;
- markdecl:(BOOL)flag;

- grepTmpvars:aStmt;
- grepBlocks:aStmt;
- grepTopblks:aStmt;
- grepCaches:aStmt;
- processBlocks;
- genblockdefsOn:stream;
- grepScope:aBlock;

- findIdentifier;
- (BOOL) containsStatic;

- add:aNode;
- grepIvars:aSet addItype:bNode to:bSet;
- grepIvars:aSet initvars:iv addItype:bNode to:bSet;
- forMethod:aMethod;
- argsstmt:statements;

- outputOn:stream;
- taglessOn:stream;
- genfieldOn:stream;
- funheadOn:stream;
- genOn:stream;
- printOn:(IOD)f;
@end

#endif				/* __NODE_H__ */

