
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: options.h,v 1.18 1998/10/06 15:23:45 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __OPTIONS_H__
#define __OPTIONS_H__

#ifndef __OBJECT_INCLUDED__
#define __OBJECT_INCLUDED__
#include <stdio.h>
#include "Object.h"
#endif

extern id options;		/* global keeping compiler invocation options */

@interface Options : Object
{
  BOOL quiet;
  BOOL version;
  BOOL outputCode;
  BOOL genCode;
  BOOL otb;
  BOOL fwd;
  BOOL selptr;
  BOOL outputObjc;
  BOOL sharedData;
  id inFile;
  id outFile;
  id srcfilename;
  id tagformat;
  id initCall;
  id mainFunction;
  STR pathSeparator;
  BOOL seltranslation;
  BOOL inlineCache;
  BOOL lineTags;
  BOOL postLink;
  BOOL checkbind;
  BOOL warnclasstype;
  BOOL warntypeconflict;
  BOOL warnundefined;
  BOOL warnnotfound;
  BOOL warnlocalnst;
  BOOL isBuffered;
  BOOL comments;
  BOOL gnu;
  BOOL asmKeyword;
  BOOL llKeyword;
  BOOL msdos;
  BOOL watcom;
  BOOL cplus;
  BOOL debugInfo;
  BOOL ppi;
  BOOL onePfile;
  BOOL blocks;
  BOOL filerCode;
  id bind;
  int lineMax;
  BOOL ibmvac;
  BOOL warnLex;
  BOOL cache;
  BOOL nilRcvr;
  BOOL selfAssign;
  BOOL cats;
  BOOL refBind;
}

+ new;

- linemax:(int)flag;
- (int) lineMax;
- categories:(BOOL)flag;
- (BOOL) cats;
- otb:(BOOL)flag;
- (BOOL) otb;
- fwd:(BOOL)flag;
- (BOOL) fwd;
- selptr:(BOOL)flag;
- (BOOL) selptr;
- selfAssign:(BOOL)flag;
- (BOOL) selfAssign;
- refBind:(BOOL)flag;
- (BOOL) refBind;
- nilRcvr:(BOOL)flag;
- (BOOL) nilRcvr;
- cache:(BOOL)flag;
- (BOOL) cache;
- bind:arg;
- bind;
- filerCode:(BOOL)flag;
- (BOOL) filerCode;
- blocks:(BOOL)flag;
- (BOOL) blocks;
- llkeyword:(BOOL)flag;
- (BOOL) llKeyword;
- asmKeyword:(BOOL)flag;
- (BOOL) asmKeyword;
- onePfile:(BOOL)flag;
- (BOOL) onePfile;
- quiet:(BOOL)flag;
- (BOOL) quiet;
- pathsep:(STR)aSep;
- (STR) pathSeparator;
- ppi:(BOOL)flag;
- (BOOL) ppi;
- debugInfo:(BOOL)flag;
- (BOOL) debugInfo;
- setCplus:(BOOL)flag;
- (BOOL) cplus;
- msdos:(BOOL)flag;
- (BOOL) msdos;
- watcom:(BOOL)flag;
- (BOOL) watcom;
- ibmvac:(BOOL)flag;
- (BOOL) ibmvac;
- gnu:(BOOL)flag;
- (BOOL) gnu;
- comments:(BOOL)flag;
- (BOOL) comments;
- outputCode:(BOOL)flag;
- (BOOL) outputCode;
- seltranslation:(BOOL)flag;
- (BOOL) seltranslation;
- genCode:(BOOL)flag;
- (BOOL) genCode;
- buffered:(BOOL)flag;
- (BOOL) isBuffered;
- linetags:(BOOL)flag;
- (BOOL) lineTags;
- shareddata:(BOOL)flag;
- (BOOL) sharedData;
- version:(BOOL)flag;
- (BOOL) version;
- inlineCache:(BOOL)flag;
- (BOOL) inlineCache;
- warnlex:(BOOL)flag;
- (BOOL) warnLex;
- warnclasstype:(BOOL)flag;
- (BOOL) warnclasstype;
- warntypeconflict:(BOOL)flag;
- (BOOL) warntypeconflict;
- warnnotfound:(BOOL)flag;
- (BOOL) warnnotfound;
- warnlocalnst:(BOOL)flag;
- (BOOL) warnlocalnst;
- warnundefined:(BOOL)flag;
- (BOOL) warnundefined;
- checkBind:(BOOL)flag;
- (BOOL) checkbind;
- postlink:(BOOL)flag;
- (BOOL) postLink;
- inFile:aString;
- inFile;
- srcfilename:aString;
- srcfilename;
- setOutFile:aString;
- outFile;
- tagformat:aString;
- tagformat;
- initCall:aString;
- initCall;
- mainfun:aString;
- mainFunction;
@end

#endif				/* __OPTIONS_H__ */

