
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: token.h,v 1.15 1998/10/06 15:23:46 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __TOKEN_H__
#define __TOKEN_H__

#include "node.h"

@interface Token : Node
{
  id lineTag;
  STR token;
}

- setUp:(STR)aToken;
- lineTag;
+ newToken:(STR)aToken;
+ str:(STR)aToken;
- free;

- outputOn:stream;
- taglessOn:stream;
- tagOn:stream;

- (STR) str;
- (BOOL) isEqual:aToken;
- (BOOL) isEqualSTR:(STR)s;
- (BOOL) containsTypedef;
- (BOOL) containsStatic;
- (BOOL) isPtr;
- (BOOL) isId;
- (BOOL) isVoid;
- findIdentifier;
- grepIvars:aSet addItype:bNode to:bSet;
- grepIvars:aSet initvars:iv addItype:bNode to:bSet;

- asIdentifier;

#ifdef __PORTABLE_OBJC__

- fileOutOn:aFiler;
- fileInFrom:aFiler;
#endif				/* __PORTABLE_OBJC__ */

@end

#endif				/* __TOKEN_H__ */

